趣味算法------猴子吃桃(循环,递归双重解法)

题目描述

猴子第一天摘下若干个桃子,当天吃了一半,后面又多吃一个。第二天早上又将剩下的桃子吃掉一半,又多吃了一个。后面每天猴子都吃了前一天剩下的一半零一个。到第十天想再吃时,只剩下一个桃子。求第一天共摘了多少桃子。

输入格式
无。

输出格式
一个整数。

解题思路:

这个题目可以使用递归求或者循环求和解出。

循环求和:

我们可以初始化 n 为最后一天的桃子数目 1,然后经过一次循环让n变成倒数第二天的桃子数目 n = 2*(n+1),重复循环9次得到最初的桃子数目。

递归求和:

因为我们知道当天的桃子数目为前一天的桃子数目加上1再乘以二倍。所以递归函数的返回值为 2*(fun(n-1)+1),fun(n)表示第n天的桃子数目,退出递归的边界条件为n==1时返回1。

具体代码:

循环方案代码:

复制代码
#include<stdio.h>
int main(void)
{

    int n = 1,i;
    for(i = 0;i<9;i++)
    {
        n = 2*(n+1);
    }

    printf("%d",n);
}

递归方案代码:

复制代码
#include<stdio.h>
int fun(int n)
{
    if(n == 1)
        return 1;
    return 2*(fun(n-1) + 1);
}
int main(void)
{
    printf("%d",fun(10));
}

总结:

解题的方法很简单,但是这道题反映了一个算法的经典的思想,已知结果求初始过程。

实则这道题也有其他的变种,比如老鼠藏奶酪问题。而且这道题也并不局限10天。

相关推荐
Navigator_Z1 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
D e re k ZH2 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶3 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
雪落漂泊3 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法
LabVIEW开发5 小时前
LabVIEW 连接板:28 个端子怎么排,优先级怎么定
java·算法·labview
严肃小白兔6 小时前
MATLAB 数值计算中的精度与误差问题:浮点运算、误差传播与数值稳定性
人工智能·算法·matlab
Hhy_11076 小时前
《C++深度解构06》手撕 string —— 从底层内存管理到深浅拷贝彻底吃透
c语言·开发语言·c++·学习·visual studio
青少儿编程课堂7 小时前
蓝桥杯青少组图形化省考报名倒计时·全国青少年信息素养大赛·电子学会图形化考级:校园黑白棋人机对战解析
c++·python·算法·bfs·信息学竞赛
jktantan8 小时前
注解式脱敏:用 Jackson 的 ContextualSerializer 做字段级策略(一)
spring boot·后端·算法·spring cloud·系统架构
曦樂~18 小时前
Cpp面筋
c语言·c++